
#ifndef _GAME_H_
#define _GAME_H_

#include "AEEModGen.h"          // Module interface definitions
#include "AEEAppGen.h"          // Applet interface definitions
#include "AEEShell.h"           // Shell interface definitions

#include "AEEStdLib.h"

#include "AEEGL.h"
#include "IGL.h"

#include "Renderer.h"

#define ITOFP(x) ((x)<<16)

class Game
{
private:
	IShell *		mShell;
	IDisplay *		mDisplay;

	AEEDeviceInfo	mDeviceInfo;

	boolean			mKeysDown[AVK_LAST - AVK_FIRST];

	Renderer		mRenderer;
	int				mRotateAngle;

public:
	boolean Create(IShell * shell, IDisplay * display);
	void Destroy();

	void Tick(int timeElapsed);

	void KeyPressed(int keyCode);
	void KeyReleased(int keyCode);

	IShell * GetShell(){ return mShell;}
	IDisplay * GetDisplay(){ return mDisplay;}

	int GetWidth(){ return mDeviceInfo.cxScreen;}
	int GetHeight(){ return mDeviceInfo.cyScreen;}
};

#endif
